
#include <windows.h>
#include "resource.h"
#include <commctrl.h>
#include <shlwapi.h>

#pragma message( "I LOVE C++") 

#pragma comment(linker, "/nodefaultlib:libc.lib")
#pragma comment(linker, "/defaultlib:MSVCRT.LIB")

#pragma comment( lib, "comctl32.lib" )

#pragma comment(linker, "/OPT:NOWIN98")

LRESULT CALLBACK DlgProcCopy(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgProcAbout(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgProcMain(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

BOOL GetFileName(char *filename,bool opendlg);
void CopyExtra(void);

HWND hMain,hCopy,hAbout;
HINSTANCE hIns;
bool cencel=false;
HMODULE hShellRes=LoadLibrary("Shell32.dll");

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	//	Get a Instance Handle for other Functions 
	hIns=hInstance;

	//	Show Main Window
	DialogBox(hInstance, (LPCTSTR)IDD_MAIN, 0, (DLGPROC)DlgProcMain);
	
		//	Exit
		return 0;
}

LRESULT CALLBACK DlgProcMain(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_COMMAND:
		{
		char szofn[2048];	
			if (LOWORD(wParam) == IDC_OPEN_S)// "Source File Name" Button Clicked
		{
			if(GetFileName(szofn,true))
				SetWindowText(GetDlgItem(hWnd,IDC_TXT_S),szofn);
			else
				SetWindowText(GetDlgItem(hWnd,IDC_TXT_S),"");

		}
	
			if (LOWORD(wParam) == IDC_OPEN_D)// "Destination File Name" Button Clicked
		{
			if(GetFileName(szofn,false))
				SetWindowText(GetDlgItem(hWnd,IDC_TXT_D),szofn);
			else
				SetWindowText(GetDlgItem(hWnd,IDC_TXT_D),"");

		}
			if (LOWORD(wParam) == IDC_COPY_S)// "Start Copy" Button Clicked
		{
			if (GetWindowTextLength(GetDlgItem(hWnd,IDC_TXT_S)) < 1 || GetWindowTextLength(GetDlgItem(hWnd,IDC_TXT_D)) <1 )
				MessageBox(hWnd ,"Please choose source and destination file name.","Error",MB_OK | MB_ICONERROR );
				else
				DialogBox(hIns, (LPCTSTR)IDD_COPY, hWnd, (DLGPROC)DlgProcCopy);
			}
			if (LOWORD(wParam) == IDC_BTN_HELP)// "HELP" Button Clicked
		{
		ShellExecute(NULL,"open","http://www.geocities.com/arshadlati",NULL,NULL,SW_SHOWNORMAL);
		}
			if (LOWORD(wParam) == IDC_BTN_ABOUT)// "About" Button Clicked
		{
		DialogBox(hIns, (LPCTSTR)IDD_ABOUT, hWnd, (DLGPROC)DlgProcAbout);
		}
			if (LOWORD(wParam) == IDC_BTN_EXIT)// "Exit" Button Clicked
		{
				 // Terminate An Application
				SendMessage(hWnd,WM_CLOSE ,NULL,NULL);
			
		}

			break;
		}

	case WM_INITDIALOG:
		{
		
			hMain=hWnd;
		
		// Set Main Window Icon
			 HICON hIco=LoadIcon(hIns,MAKEINTRESOURCE(IDI_MAINA));
			 SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)hIco);
			
		// Set Radio Button "Bytes" State To Checked
			 SendMessage(GetDlgItem(hWnd,IDC_RADIO1),BM_SETCHECK,BST_CHECKED,NULL);
		
		// Set Text Box "Extra Bytes" Text To "1"
		// And Limit Text Length (4)
			 SetDlgItemInt(hWnd,IDC_TXT_EB,1,0);
			 SendMessage(GetDlgItem(hWnd,IDC_TXT_EB),EM_LIMITTEXT,4,NULL);

		return true;
		}

	case WM_CLOSE:
		{
			PostQuitMessage(0);
			DestroyWindow(hWnd);
			break;
		}
	case WM_DESTROY:
		{
			PostQuitMessage(0);
			DestroyWindow(hWnd);
			break;
		}
	
	}
	return FALSE;
}

LRESULT CALLBACK DlgProcCopy(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_COMMAND:
		{
			if (LOWORD(wParam) == IDCANCEL)// "Cencel" Button Clicked
		{
		cencel=true;
		EndDialog(hWnd,1);
		}

			break;
		}

	case WM_INITDIALOG:
		{
			hCopy=hWnd;
			cencel=false;
			// Initializes  Common Controls 
			 InitCommonControls();
			 
			 // Load AVI from Shell32.Dll
			 Animate_OpenEx(GetDlgItem(hWnd,IDC_ANIMATE),hShellRes,MAKEINTRESOURCE(160));
			
			 // Start Copy By Creating A New Thread
			 DWORD threadID;
			 HANDLE countHandle=CreateThread(0, 0,
			(LPTHREAD_START_ROUTINE) CopyExtra,
			0, 0, &threadID);

			

		return true;
		}

	case WM_CLOSE:
		{
			cencel=true;
			EndDialog(hWnd,1);
			
			break;
		}
	case WM_DESTROY:
		{
		cencel=true;
			DestroyWindow(hWnd);
			break;
		}
	
	}
	return FALSE;
}


LRESULT CALLBACK DlgProcAbout(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_COMMAND:
		{
			if (LOWORD(wParam) == IDC_OK)// "OK" Button Clicked
		{
		EndDialog(hWnd,1);
		}

			break;
		}

	case WM_INITDIALOG:
		{
			hAbout=hWnd;
			 
			HICON hIco=LoadIcon(NULL,IDI_INFORMATION);
			SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)hIco);
			char sztxt[2048];
			sztxt[0]='T';
			sztxt[1]=0;
			StrCat(sztxt,"his software is made by\xD\xA\tMuhammad Arshad\xD\xA\xD\xA");
			StrCat(sztxt,"Please provide me feedback by Sending  mail at my Postal Address.");
			StrCat(sztxt,"\xD\xA\xD\xA Name       :Muhammad Arshad\xD\xA S/O        :Muhammad Sher\xD\xA Village    :Thathi Jalal \xD\xA");
			StrCat(sztxt," P.O.       :Rubana \xD\xA Tehsil     :Sahiwal \xD\xA District   :Sargodha \xD\xA \t(Punjab) \xD\xA         \t Pakistan");
		
			SetWindowText(GetDlgItem( hWnd,IDC_TXT_ABOUT),sztxt);
		return true;
		}

	case WM_CLOSE:
		{
		EndDialog(hWnd,1);
			break;
		}
	case WM_DESTROY:
		{
		DestroyWindow(hWnd);
			break;
		}
	
	}
	return FALSE;
}


BOOL GetFileName(char *filename,bool opendlg)
{
OPENFILENAME ofn;
char szFileName[2048];

ZeroMemory(&ofn, sizeof(ofn));

szFileName[0] = '\0';
	
	ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = hMain;
    ofn.lpstrFilter = "All Files (*.*)\0*.*\0"; //
    ofn.lpstrFile = szFileName;
    ofn.nMaxFile = 2048;
    ofn.lpstrDefExt = "*";
  
	if (opendlg==true)
	{

	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrTitle = "Open File..";
	if(GetOpenFileName(&ofn))
	{ 
    lstrcpy(filename, szFileName);
    return TRUE;
	}
	
	}
	else
	{

	ofn.Flags = OFN_OVERWRITEPROMPT;
	ofn.lpstrTitle = "Save File..";
	if(GetSaveFileName(&ofn))
	{ 
    lstrcpy(filename, szFileName);
    return TRUE;

	}
	}

	return FALSE;	
}

void CopyExtra(void)
{
cencel=false;

HANDLE hFile,hDesFile; 
char szsf[2048];
char szdf[2048];

int ilen=GetWindowText(GetDlgItem(hMain,IDC_TXT_S),szsf,2048);
szsf[ilen]='\0';
ilen=GetWindowText(GetDlgItem(hMain,IDC_TXT_D),szdf,2048);
szdf[ilen]='\0';



hFile = CreateFile(szsf,          
                GENERIC_READ ,             
                NULL,            
                NULL,                     
                OPEN_EXISTING,            
                FILE_ATTRIBUTE_NORMAL,     
                NULL);

if (hFile==INVALID_HANDLE_VALUE)
{
	StrCpy(szdf,"Cant open source file.\n\"");
	StrCat(szdf,szsf);
	StrCat(szdf,"\"");
	MessageBox(hMain ,szdf,"Error",MB_OK | MB_ICONERROR );
	EndDialog(hCopy,NULL);
	return ;
}

DWORD fsize=GetFileSize(hFile,NULL);

hDesFile = CreateFile(szdf,          
                GENERIC_WRITE,             
                NULL,            
                NULL,                     
                CREATE_NEW,            
                FILE_ATTRIBUTE_NORMAL,     
                NULL);

if (hDesFile==INVALID_HANDLE_VALUE)
{
	CloseHandle(hFile);
	StrCpy(szsf,"Cant create destination file.\n\"");
	StrCat(szsf,szdf);
	StrCat(szsf,"\"");
	MessageBox(hMain ,szsf,"Error",MB_OK | MB_ICONERROR );
	EndDialog(hCopy,NULL);
	return ;
}

BOOL success;
DWORD numWrite,numRead,cp;
HWND hpro=GetDlgItem(hCopy,IDC_PROGRESS1);
HWND hpro2=GetDlgItem(hCopy,IDC_PROGRESS2);
cp=0;
char rw[9999];

SendMessage(hpro,PBM_SETRANGE,NULL, MAKELPARAM (0, 65535));
SendMessage(hpro,PBM_SETSTEP,1, NULL);

do
{
	if (cencel==true)
					break;
  success = ReadFile(hFile, rw, 10000,&numRead, 0);

  WriteFile(hDesFile, rw,numRead, &numWrite, 0);

  SendMessage(hpro,PBM_STEPIT,NULL,NULL);
}
while (numRead>0 && success);
 
SendMessage(hpro,PBM_SETPOS,65535,NULL);


char *ch=(char * )GlobalAlloc(GPTR,1048576) ;

DWORD numW;

if (IsDlgButtonChecked(hMain,IDC_RADIO1)==BST_CHECKED)
			numW=1;
if (IsDlgButtonChecked(hMain,IDC_RADIO2)==BST_CHECKED)
			numW=1024;
if (IsDlgButtonChecked(hMain,IDC_RADIO3)==BST_CHECKED)
			numW=1048576;


int eb=GetDlgItemInt(hMain,IDC_TXT_EB,NULL,false);
if (eb>0 && cencel==false)
{
SendMessage(hpro2,PBM_SETRANGE,NULL, MAKELPARAM (0, eb));
int i;
for ( i = 0 ; i < eb ; i++ )
{
	if (cencel==true)
		break;
WriteFile(hDesFile, ch,numW, &numWrite, 0);
SendMessage(hpro2,PBM_SETPOS,i,NULL);
}
	
}
	
	GlobalFree((HGLOBAL)ch);	
	CloseHandle(hFile);
	CloseHandle(hDesFile);
	SetWindowText(GetDlgItem(hCopy,IDCANCEL),"Close");
	Animate_Seek(GetDlgItem(hCopy,IDC_ANIMATE),30);
	Animate_Stop(GetDlgItem(hCopy,IDC_ANIMATE));
	SendMessage(hpro2,PBM_SETPOS,SendMessage(hpro2,PBM_GETRANGE,FALSE, NULL),NULL);	

}
